diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-remote-station-manager.h ns-3.40/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.39/src/wifi/model/wifi-remote-station-manager.h	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-remote-station-manager.h	2023-09-27 13:30:37.918840000 -0700
@@ -99,23 +99,21 @@
      * WifiRemoteStationManager::GetNSupported() and
      * WifiRemoteStationManager::GetSupported().
      */
-    WifiModeList m_operationalRateSet;        //!< operational rate set
-    WifiModeList m_operationalMcsSet;         //!< operational MCS set
-    Mac48Address m_address;                   //!< Mac48Address of the remote station
-    uint16_t m_aid;                           /**< AID of the remote station (unused if this object
-                                                   is installed on a non-AP station) */
-    std::optional<Mac48Address> m_mldAddress; /**< MLD MAC address if the remote station is
-                                                   affiliated with an MLD */
-    WifiRemoteStationInfo m_info;             //!< remote station info
-    bool m_dsssSupported;                     //!< Flag if DSSS is supported by the remote station
-    bool m_erpOfdmSupported; //!< Flag if ERP OFDM is supported by the remote station
-    bool m_ofdmSupported;    //!< Flag if OFDM is supported by the remote station
+    WifiModeList m_operationalRateSet; //!< operational rate set
+    WifiModeList m_operationalMcsSet;  //!< operational MCS set
+    Mac48Address m_address;            //!< Mac48Address of the remote station
+    uint16_t m_aid;                    /**< AID of the remote station (unused if this object
+                                            is installed on a non-AP station) */
+    WifiRemoteStationInfo m_info;      //!< remote station info
+    bool m_dsssSupported;              //!< Flag if DSSS is supported by the remote station
+    bool m_erpOfdmSupported;           //!< Flag if ERP OFDM is supported by the remote station
+    bool m_ofdmSupported;              //!< Flag if OFDM is supported by the remote station
     Ptr<const HtCapabilities> m_htCapabilities;   //!< remote station HT capabilities
     Ptr<const VhtCapabilities> m_vhtCapabilities; //!< remote station VHT capabilities
     Ptr<const HeCapabilities> m_heCapabilities;   //!< remote station HE capabilities
     Ptr<const EhtCapabilities> m_ehtCapabilities; //!< remote station EHT capabilities
-    /// remote station EML capabilities
-    std::shared_ptr<CommonInfoBasicMle::EmlCapabilities> m_emlCapabilities;
+    /// remote station Multi-Link Element Common Info
+    std::shared_ptr<CommonInfoBasicMle> m_mleCommonInfo;
     bool m_emlsrEnabled; //!< whether EMLSR mode is enabled on this link
 
     uint16_t m_channelWidth;  //!< Channel width (in MHz) supported by the remote station
@@ -270,14 +268,14 @@
      */
     void AddStationEhtCapabilities(Mac48Address from, EhtCapabilities ehtCapabilities);
     /**
-     * Records EML capabilities of the remote station.
+     * Records the Common Info field advertised by the given remote station in a Multi-Link
+     * Element. It includes the MLD address of the remote station.
      *
      * \param from the address of the station being recorded
-     * \param emlCapabilities the EML capabilities of the station
+     * \param mleCommonInfo the MLE Common Info advertised by the station
      */
-    void AddStationEmlCapabilities(
-        Mac48Address from,
-        const std::shared_ptr<CommonInfoBasicMle::EmlCapabilities>& emlCapabilities);
+    void AddStationMleCommonInfo(Mac48Address from,
+                                 const std::shared_ptr<CommonInfoBasicMle>& mleCommonInfo);
     /**
      * Return the HT capabilities sent by the remote station.
      *
@@ -310,8 +308,14 @@
      * \param from the (MLD or link) address of the remote non-AP MLD
      * \return the EML Capabilities advertised by the remote non-AP MLD
      */
-    std::shared_ptr<CommonInfoBasicMle::EmlCapabilities> GetStationEmlCapabilities(
-        const Mac48Address& from);
+    std::optional<std::reference_wrapper<CommonInfoBasicMle::EmlCapabilities>>
+    GetStationEmlCapabilities(const Mac48Address& from);
+    /**
+     * \param from the (MLD or link) address of the remote non-AP MLD
+     * \return the MLD Capabilities advertised by the remote non-AP MLD
+     */
+    std::optional<std::reference_wrapper<CommonInfoBasicMle::MldCapabilities>>
+    GetStationMldCapabilities(const Mac48Address& from);
     /**
      * Return whether the device has HT capability support enabled.
      *
@@ -785,14 +789,6 @@
     void SetPsMode(const Mac48Address& address, bool isInPsMode);
 
     /**
-     * Set the address of the MLD the given station is affiliated with.
-     *
-     * \param address the MAC address of the remote station
-     * \param mldAddress the MAC address of the MLD the remote station is
-     *                   affiliated with
-     */
-    void SetMldAddress(const Mac48Address& address, const Mac48Address& mldAddress);
-    /**
      * Get the address of the MLD the given station is affiliated with, if any.
      * Note that an MLD address is only present if an ML discovery/setup was performed
      * with the given station (which requires both this station and the given
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-spectrum-phy-interface.cc ns-3.40/src/wifi/model/wifi-spectrum-phy-interface.cc
--- ns-3.39/src/wifi/model/wifi-spectrum-phy-interface.cc	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-spectrum-phy-interface.cc	2023-09-27 13:30:37.918840000 -0700
@@ -45,7 +45,7 @@
       m_centerFrequency{0},
       m_channelWidth{0},
       m_bands{},
-      m_ruBands{}
+      m_heRuBands{}
 {
     NS_LOG_FUNCTION(this << freqRange);
 }
@@ -59,7 +59,7 @@
     m_netDevice = nullptr;
     m_channel = nullptr;
     m_bands.clear();
-    m_ruBands.clear();
+    m_heRuBands.clear();
 }
 
 void
@@ -158,27 +158,27 @@
 }
 
 void
-WifiSpectrumPhyInterface::SetBands(WifiSpectrumPhyInterface::WifiSpectrumBands&& bands)
+WifiSpectrumPhyInterface::SetBands(WifiSpectrumBands&& bands)
 {
     m_bands = std::move(bands);
 }
 
-const WifiSpectrumPhyInterface::WifiSpectrumBands&
+const WifiSpectrumBands&
 WifiSpectrumPhyInterface::GetBands() const
 {
     return m_bands;
 }
 
 void
-WifiSpectrumPhyInterface::SetRuBands(HePhy::RuBands&& ruBands)
+WifiSpectrumPhyInterface::SetHeRuBands(HeRuBands&& heRuBands)
 {
-    m_ruBands = std::move(ruBands);
+    m_heRuBands = std::move(heRuBands);
 }
 
-const HePhy::RuBands&
-WifiSpectrumPhyInterface::GetRuBands() const
+const HeRuBands&
+WifiSpectrumPhyInterface::GetHeRuBands() const
 {
-    return m_ruBands;
+    return m_heRuBands;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-spectrum-phy-interface.h ns-3.40/src/wifi/model/wifi-spectrum-phy-interface.h
--- ns-3.39/src/wifi/model/wifi-spectrum-phy-interface.h	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-spectrum-phy-interface.h	2023-09-27 13:30:37.918840000 -0700
@@ -126,9 +126,6 @@
                             uint32_t bandBandwidth,
                             uint16_t guardBandwidth);
 
-    /// vector of spectrum bands handled by this interface
-    using WifiSpectrumBands = std::vector<WifiSpectrumBandInfo>;
-
     /**
      * Set the vector of spectrum bands handled by this interface
      *
@@ -145,15 +142,15 @@
     /**
      * Set the HE RU spectrum bands handled by this interface (if any)
      *
-     * \param ruBands the HE RU spectrum bands
+     * \param heRuBands the HE RU spectrum bands
      */
-    void SetRuBands(HePhy::RuBands&& ruBands);
+    void SetHeRuBands(HeRuBands&& heRuBands);
     /**
      * Get the HE RU spectrum bands handled by this interface
      *
      * \return the HE RU spectrum bands
      */
-    const HePhy::RuBands& GetRuBands() const;
+    const HeRuBands& GetHeRuBands() const;
 
   private:
     void DoDispose() override;
@@ -168,7 +165,7 @@
 
     WifiSpectrumBands
         m_bands; /**< Store all the distinct spectrum bands associated with every channels widths */
-    HePhy::RuBands m_ruBands; /**< Store all the distinct spectrum bands associated with every RU */
+    HeRuBands m_heRuBands; /**< Store all the distinct spectrum bands associated with every RU */
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-spectrum-signal-parameters.cc ns-3.40/src/wifi/model/wifi-spectrum-signal-parameters.cc
--- ns-3.39/src/wifi/model/wifi-spectrum-signal-parameters.cc	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-spectrum-signal-parameters.cc	2023-09-27 13:30:37.918840000 -0700
@@ -31,16 +31,14 @@
 
 WifiSpectrumSignalParameters::WifiSpectrumSignalParameters()
     : SpectrumSignalParameters(),
-      ppdu(nullptr),
-      txWidth(0)
+      ppdu(nullptr)
 {
     NS_LOG_FUNCTION(this);
 }
 
 WifiSpectrumSignalParameters::WifiSpectrumSignalParameters(const WifiSpectrumSignalParameters& p)
     : SpectrumSignalParameters(p),
-      ppdu(p.ppdu),
-      txWidth(p.txWidth)
+      ppdu(p.ppdu)
 {
     NS_LOG_FUNCTION(this << &p);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-spectrum-signal-parameters.h ns-3.40/src/wifi/model/wifi-spectrum-signal-parameters.h
--- ns-3.39/src/wifi/model/wifi-spectrum-signal-parameters.h	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-spectrum-signal-parameters.h	2023-09-27 13:30:37.918840000 -0700
@@ -50,7 +50,6 @@
     WifiSpectrumSignalParameters(const WifiSpectrumSignalParameters& p);
 
     Ptr<const WifiPpdu> ppdu; ///< The PPDU being transmitted
-    uint16_t txWidth;         ///< The TX width in MHz
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-tx-timer.cc ns-3.40/src/wifi/model/wifi-tx-timer.cc
--- ns-3.39/src/wifi/model/wifi-tx-timer.cc	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-tx-timer.cc	2023-09-27 13:30:37.918840000 -0700
@@ -129,6 +129,19 @@
     NS_LOG_FUNCTION(this << GetReasonString(m_reason));
     m_timeoutEvent.Cancel();
     m_impl = nullptr;
+    m_staExpectResponseFrom.clear();
+}
+
+void
+WifiTxTimer::GotResponseFrom(const Mac48Address& from)
+{
+    m_staExpectResponseFrom.erase(from);
+}
+
+const std::set<Mac48Address>&
+WifiTxTimer::GetStasExpectedToRespond() const
+{
+    return m_staExpectResponseFrom;
 }
 
 Time
@@ -174,13 +187,14 @@
 }
 
 void
-WifiTxTimer::FeedTraceSource(WifiPsduMap* psduMap,
-                             std::set<Mac48Address>* missingStations,
-                             std::size_t nTotalStations)
+WifiTxTimer::FeedTraceSource(WifiPsduMap* psduMap, std::size_t nTotalStations)
 {
     if (!m_psduMapResponseTimeoutCallback.IsNull())
     {
-        m_psduMapResponseTimeoutCallback(m_reason, psduMap, missingStations, nTotalStations);
+        m_psduMapResponseTimeoutCallback(m_reason,
+                                         psduMap,
+                                         &m_staExpectResponseFrom,
+                                         nTotalStations);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-tx-timer.h ns-3.40/src/wifi/model/wifi-tx-timer.h
--- ns-3.39/src/wifi/model/wifi-tx-timer.h	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-tx-timer.h	2023-09-27 13:30:37.918840000 -0700
@@ -81,12 +81,18 @@
      * \tparam Args \deduced Type template parameter pack
      * \param reason the reason why the timer was started
      * \param delay the time to the expiration of the timer
+     * \param from the set of stations we expect to receive a response from
      * \param mem_ptr Member method pointer to invoke
      * \param obj The object on which to invoke the member method
      * \param args The arguments to pass to the invoked method
      */
     template <typename MEM, typename OBJ, typename... Args>
-    void Set(Reason reason, const Time& delay, MEM mem_ptr, OBJ obj, Args... args);
+    void Set(Reason reason,
+             const Time& delay,
+             const std::set<Mac48Address>& from,
+             MEM mem_ptr,
+             OBJ obj,
+             Args... args);
 
     /**
      * Reschedule the timer to time out the given amount of time from the moment
@@ -125,6 +131,18 @@
     void Cancel();
 
     /**
+     * Notify that a response was got from the given station.
+     *
+     * \param from the MAC address of the given station
+     */
+    void GotResponseFrom(const Mac48Address& from);
+
+    /**
+     * \return the set of stations that are still expected to respond
+     */
+    const std::set<Mac48Address>& GetStasExpectedToRespond() const;
+
+    /**
      * Get the remaining time until the timer will expire.
      *
      * \return the remaining time until the timer will expire.
@@ -216,18 +234,17 @@
      * timeout callback.
      *
      * \param psduMap the PSDU map for which not all responses were received
-     * \param missingStations the set of stations that did not respond
      * \param nTotalStations the total number of expected responses
      */
-    void FeedTraceSource(WifiPsduMap* psduMap,
-                         std::set<Mac48Address>* missingStations,
-                         std::size_t nTotalStations);
+    void FeedTraceSource(WifiPsduMap* psduMap, std::size_t nTotalStations);
 
     EventId m_timeoutEvent; //!< the timeout event after a missing response
     Reason m_reason;        //!< the reason why the timer was started
     Ptr<EventImpl> m_impl;  /**< the timer implementation, which contains the bound
                                  callback function and arguments */
     Time m_end;             //!< the absolute time when the timer will expire
+    std::set<Mac48Address>
+        m_staExpectResponseFrom; //!< the set of stations we expect to receive a response from
 
     /// the MPDU response timeout callback
     mutable MpduResponseTimeout m_mpduResponseTimeoutCallback;
@@ -248,13 +265,19 @@
 
 template <typename MEM, typename OBJ, typename... Args>
 void
-WifiTxTimer::Set(Reason reason, const Time& delay, MEM mem_ptr, OBJ obj, Args... args)
+WifiTxTimer::Set(Reason reason,
+                 const Time& delay,
+                 const std::set<Mac48Address>& from,
+                 MEM mem_ptr,
+                 OBJ obj,
+                 Args... args)
 {
     typedef void (WifiTxTimer::*TimeoutType)(MEM, OBJ, Args...);
 
     m_timeoutEvent = Simulator::Schedule(delay, &WifiTxTimer::Expire, this);
     m_reason = reason;
     m_end = Simulator::Now() + delay;
+    m_staExpectResponseFrom = from;
 
     // create an event to invoke when the timer expires
     m_impl = Ptr<EventImpl>(MakeEvent<TimeoutType>(&WifiTxTimer::Timeout,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-tx-vector.cc ns-3.40/src/wifi/model/wifi-tx-vector.cc
--- ns-3.39/src/wifi/model/wifi-tx-vector.cc	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-tx-vector.cc	2023-09-27 13:30:37.918840000 -0700
@@ -27,6 +27,8 @@
 
 #include <algorithm>
 #include <iterator>
+#include <numeric>
+#include <set>
 
 namespace ns3
 {
@@ -217,6 +219,7 @@
 uint8_t
 WifiTxVector::GetNssMax() const
 {
+    // We do not support mixed OFDMA and MU-MIMO
     uint8_t nss = 0;
     if (IsMu())
     {
@@ -233,6 +236,26 @@
 }
 
 uint8_t
+WifiTxVector::GetNssTotal() const
+{
+    // We do not support mixed OFDMA and MU-MIMO
+    uint8_t nss = 0;
+    if (IsMu())
+    {
+        nss = std::accumulate(
+            m_muUserInfos.cbegin(),
+            m_muUserInfos.cend(),
+            0,
+            [](uint8_t prevNss, const auto& info) { return prevNss + info.second.nss; });
+    }
+    else
+    {
+        nss = m_nss;
+    }
+    return nss;
+}
+
+uint8_t
 WifiTxVector::GetNess() const
 {
     return m_ness;
@@ -259,8 +282,7 @@
 bool
 WifiTxVector::IsNonHtDuplicate() const
 {
-    return ((m_channelWidth >= 40) && !IsMu() &&
-            (GetMode().GetModulationClass() < WIFI_MOD_CLASS_HT));
+    return ((m_channelWidth >= 40) && !IsMu() && (GetModulationClass() < WIFI_MOD_CLASS_HT));
 }
 
 void
@@ -440,25 +462,64 @@
     {
         if (m_nss != 3 && m_nss != 6)
         {
-            return (modeName != "VhtMcs9");
+            if (modeName == "VhtMcs9")
+            {
+                return false;
+            }
         }
     }
     else if (m_channelWidth == 80)
     {
         if (m_nss == 3 || m_nss == 7)
         {
-            return (modeName != "VhtMcs6");
+            if (modeName == "VhtMcs6")
+            {
+                return false;
+            }
         }
         else if (m_nss == 6)
         {
-            return (modeName != "VhtMcs9");
+            if (modeName == "VhtMcs9")
+            {
+                return false;
+            }
         }
     }
     else if (m_channelWidth == 160)
     {
         if (m_nss == 3)
         {
-            return (modeName != "VhtMcs9");
+            if (modeName == "VhtMcs9")
+            {
+                return false;
+            }
+        }
+    }
+    for (const auto& userInfo : m_muUserInfos)
+    {
+        if (GetNumStasInRu(userInfo.second.ru) > 8)
+        {
+            return false;
+        }
+    }
+    std::map<HeRu::RuSpec, uint8_t> streamsPerRu{};
+    for (const auto& info : m_muUserInfos)
+    {
+        auto it = streamsPerRu.find(info.second.ru);
+        if (it == streamsPerRu.end())
+        {
+            streamsPerRu[info.second.ru] = info.second.nss;
+        }
+        else
+        {
+            it->second += info.second.nss;
+        }
+    }
+    for (auto& streams : streamsPerRu)
+    {
+        if (streams.second > 8)
+        {
+            return false;
         }
     }
     return true;
@@ -483,6 +544,60 @@
 }
 
 bool
+WifiTxVector::IsDlOfdma() const
+{
+    if (!IsDlMu())
+    {
+        return false;
+    }
+    if (IsEht(m_preamble))
+    {
+        return m_ehtPpduType == 0;
+    }
+    if (m_muUserInfos.size() == 1)
+    {
+        return true;
+    }
+    std::set<HeRu::RuSpec> rus{};
+    for (const auto& userInfo : m_muUserInfos)
+    {
+        rus.insert(userInfo.second.ru);
+        if (rus.size() > 1)
+        {
+            return true;
+        }
+    }
+    return false;
+}
+
+bool
+WifiTxVector::IsDlMuMimo() const
+{
+    if (!IsDlMu())
+    {
+        return false;
+    }
+    if (IsEht(m_preamble))
+    {
+        return m_ehtPpduType == 2;
+    }
+    if (m_muUserInfos.size() < 2)
+    {
+        return false;
+    }
+    // TODO: mixed OFDMA and MU-MIMO is not supported
+    return !IsDlOfdma();
+}
+
+uint8_t
+WifiTxVector::GetNumStasInRu(const HeRu::RuSpec& ru) const
+{
+    return std::count_if(m_muUserInfos.cbegin(),
+                         m_muUserInfos.cend(),
+                         [&ru](const auto& info) -> bool { return (ru == info.second.ru); });
+}
+
+bool
 WifiTxVector::IsAllocated(uint16_t staId) const
 {
     return m_muUserInfos.count(staId) > 0;
@@ -536,6 +651,12 @@
     return m_muUserInfos;
 }
 
+bool
+WifiTxVector::IsSigBCompression() const
+{
+    return IsDlMuMimo() && !IsDlOfdma();
+}
+
 void
 WifiTxVector::SetInactiveSubchannels(const std::vector<bool>& inactiveSubchannels)
 {
@@ -652,11 +773,18 @@
 {
     auto heRuComparator = HeRu::RuSpecCompare(m_channelWidth, p20Index);
     UserInfoMapOrderedByRus orderedMap{heRuComparator};
-    std::transform(
-        m_muUserInfos.cbegin(),
-        m_muUserInfos.cend(),
-        std::inserter(orderedMap, orderedMap.end()),
-        [](auto&& userInfo) { return std::make_pair(userInfo.second.ru, userInfo.first); });
+    for (const auto& userInfo : m_muUserInfos)
+    {
+        const auto ru = userInfo.second.ru;
+        if (auto it = orderedMap.find(ru); it != orderedMap.end())
+        {
+            it->second.emplace(userInfo.first);
+        }
+        else
+        {
+            orderedMap.emplace(userInfo.second.ru, std::set<uint16_t>{userInfo.first});
+        }
+    }
     return orderedMap;
 }
 
@@ -667,7 +795,7 @@
     std::vector<HeRu::RuType> ruTypes{};
     ruTypes.resize(ruAllocations.size());
     const auto& orderedMap = GetUserInfoMapOrderedByRus(p20Index);
-    for (const auto& [ru, staId] : orderedMap)
+    for (const auto& [ru, staIds] : orderedMap)
     {
         const auto ruType = ru.GetRuType();
         const auto ruBw = HeRu::GetBandwidth(ruType);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-tx-vector.h ns-3.40/src/wifi/model/wifi-tx-vector.h
--- ns-3.39/src/wifi/model/wifi-tx-vector.h	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-tx-vector.h	2023-09-27 13:30:37.918840000 -0700
@@ -28,6 +28,7 @@
 
 #include <list>
 #include <optional>
+#include <set>
 #include <vector>
 
 namespace ns3
@@ -248,10 +249,14 @@
      */
     uint8_t GetNss(uint16_t staId = SU_STA_ID) const;
     /**
-     * \returns the maximum number of Nss (namely if MU)
+     * \returns the maximum number of Nss over all RUs of an HE MU (used for OFDMA)
      */
     uint8_t GetNssMax() const;
     /**
+     * \returns the total number of Nss for a given RU of an HE MU (used for full bandwidth MU-MIMO)
+     */
+    uint8_t GetNssTotal() const;
+    /**
      * Sets the number of Nss
      *
      * \param nss the number of spatial streams
@@ -371,6 +376,18 @@
      */
     bool IsUlMu() const;
     /**
+     * Return true if this TX vector is used for a downlink multi-user transmission using OFDMA.
+     *
+     * \return true if this TX vector is used for a downlink multi-user transmission using OFDMA
+     */
+    bool IsDlOfdma() const;
+    /**
+     * Return true if this TX vector is used for a downlink multi-user transmission using MU-MIMO.
+     *
+     * \return true if this TX vector is used for a downlink multi-user transmission using MU-MIMO
+     */
+    bool IsDlMuMimo() const;
+    /**
      * Check if STA ID is allocated
      * \param staId STA ID
      * \return true if allocated, false otherwise
@@ -424,7 +441,7 @@
     HeMuUserInfoMap& GetHeMuUserInfoMap();
 
     /// map of specific user info parameters ordered per increasing frequency RUs
-    using UserInfoMapOrderedByRus = std::map<HeRu::RuSpec, uint16_t, HeRu::RuSpecCompare>;
+    using UserInfoMapOrderedByRus = std::map<HeRu::RuSpec, std::set<uint16_t>, HeRu::RuSpecCompare>;
 
     /**
      * Get the map of specific user info parameters ordered per increasing frequency RUs.
@@ -435,6 +452,13 @@
     UserInfoMapOrderedByRus GetUserInfoMapOrderedByRus(uint8_t p20Index) const;
 
     /**
+     * Indicate whether the Common field is present in the HE-SIG-B field.
+     *
+     * \return true if the Common field is present in the HE-SIG-B, false otherwise
+     */
+    bool IsSigBCompression() const;
+
+    /**
      * Set the 20 MHz subchannels that are punctured.
      *
      * \param inactiveSubchannels the bitmap indexed by the 20 MHz subchannels in ascending order,
@@ -523,6 +547,14 @@
      */
     Center26ToneRuIndication DeriveCenter26ToneRuIndication() const;
 
+    /**
+     * Get the number of STAs in a given RU.
+     *
+     * \param ru the RU specification
+     * \return the number of STAs in the RU
+     */
+    uint8_t GetNumStasInRu(const HeRu::RuSpec& ru) const;
+
     WifiMode m_mode;          /**< The DATARATE parameter in Table 15-4.
                               It is the value that will be passed
                               to PMD_RATE.request */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-utils.cc ns-3.40/src/wifi/model/wifi-utils.cc
--- ns-3.39/src/wifi/model/wifi-utils.cc	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-utils.cc	2023-09-27 13:30:37.918840000 -0700
@@ -144,4 +144,37 @@
     return size;
 }
 
+bool
+TidToLinkMappingValidForNegType1(const WifiTidLinkMapping& dlLinkMapping,
+                                 const WifiTidLinkMapping& ulLinkMapping)
+{
+    if (dlLinkMapping.empty() && ulLinkMapping.empty())
+    {
+        // default mapping is valid
+        return true;
+    }
+
+    if (dlLinkMapping.size() != 8 || ulLinkMapping.size() != 8)
+    {
+        // not all TIDs have been mapped
+        return false;
+    }
+
+    const auto& linkSet = dlLinkMapping.cbegin()->second;
+
+    for (const auto& linkMapping : {std::cref(dlLinkMapping), std::cref(ulLinkMapping)})
+    {
+        for (const auto& [tid, links] : linkMapping.get())
+        {
+            if (links != linkSet)
+            {
+                // distinct link sets
+                return false;
+            }
+        }
+    }
+
+    return true;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-utils.h ns-3.40/src/wifi/model/wifi-utils.h
--- ns-3.39/src/wifi/model/wifi-utils.h	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/wifi-utils.h	2023-09-27 13:30:37.918840000 -0700
@@ -22,9 +22,12 @@
 
 #include "block-ack-type.h"
 
+#include "ns3/fatal-error.h"
 #include "ns3/ptr.h"
 
 #include <list>
+#include <map>
+#include <set>
 
 namespace ns3
 {
@@ -33,6 +36,44 @@
 class Packet;
 
 /**
+ * Wifi direction. Values are those defined for the TID-to-Link Mapping Control Direction
+ * field in IEEE 802.11be D3.1 Figure 9-1002ap
+ */
+enum class WifiDirection : uint8_t
+{
+    DOWNLINK = 0,
+    UPLINK = 1,
+    BOTH_DIRECTIONS = 2,
+};
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the stream
+ * \param direction the direction
+ * \returns a reference to the stream
+ */
+inline std::ostream&
+operator<<(std::ostream& os, const WifiDirection& direction)
+{
+    switch (direction)
+    {
+    case WifiDirection::DOWNLINK:
+        return (os << "DOWNLINK");
+    case WifiDirection::UPLINK:
+        return (os << "UPLINK");
+    case WifiDirection::BOTH_DIRECTIONS:
+        return (os << "BOTH_DIRECTIONS");
+    default:
+        NS_FATAL_ERROR("Invalid direction");
+        return (os << "INVALID");
+    }
+}
+
+/// @brief TID-indexed map of the link set to which the TID is mapped
+using WifiTidLinkMapping = std::map<uint8_t, std::set<uint8_t>>;
+
+/**
  * Convert from dBm to Watts.
  *
  * \param dbm the power in dBm
@@ -129,6 +170,17 @@
  */
 uint32_t GetSize(Ptr<const Packet> packet, const WifiMacHeader* hdr, bool isAmpdu);
 
+/**
+ * Check if the given TID-to-Link Mappings are valid for a negotiation type of 1. Specifically,
+ * it is checked whether all TIDs are mapped to the same set of links.
+ *
+ * \param dlLinkMapping the given TID-to-Link Mapping for Downlink
+ * \param ulLinkMapping the given TID-to-Link Mapping for Uplink
+ * \return whether the given TID-to-Link Mappings are valid for a negotiation type of 1
+ */
+bool TidToLinkMappingValidForNegType1(const WifiTidLinkMapping& dlLinkMapping,
+                                      const WifiTidLinkMapping& ulLinkMapping);
+
 /// Size of the space of sequence numbers
 static constexpr uint16_t SEQNO_SPACE_SIZE = 4096;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/yans-wifi-channel.cc ns-3.40/src/wifi/model/yans-wifi-channel.cc
--- ns-3.39/src/wifi/model/yans-wifi-channel.cc	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/model/yans-wifi-channel.cc	2023-09-27 13:30:37.918840000 -0700
@@ -19,6 +19,7 @@
 
 #include "yans-wifi-channel.h"
 
+#include "wifi-net-device.h"
 #include "wifi-ppdu.h"
 #include "wifi-psdu.h"
 #include "wifi-utils.h"
@@ -31,7 +32,6 @@
 #include "ns3/propagation-delay-model.h"
 #include "ns3/propagation-loss-model.h"
 #include "ns3/simulator.h"
-#include "ns3/wifi-net-device.h"
 
 namespace ns3
 {
@@ -92,7 +92,7 @@
     NS_LOG_FUNCTION(this << sender << ppdu << txPowerDbm);
     Ptr<MobilityModel> senderMobility = sender->GetMobility();
     NS_ASSERT(senderMobility);
-    for (PhyList::const_iterator i = m_phyList.begin(); i != m_phyList.end(); i++)
+    for (auto i = m_phyList.begin(); i != m_phyList.end(); i++)
     {
         if (sender != (*i))
         {
@@ -137,7 +137,7 @@
     // Do no further processing if signal is too weak
     // Current implementation assumes constant RX power over the PPDU duration
     // Compare received TX power per MHz to normalized RX sensitivity
-    uint16_t txWidth = ppdu->GetTransmissionChannelWidth();
+    uint16_t txWidth = ppdu->GetTxChannelWidth();
     if ((rxPowerDbm + phy->GetRxGain()) < phy->GetRxSensitivity() + RatioToDb(txWidth / 20.0))
     {
         NS_LOG_INFO("Received signal too weak to process: " << rxPowerDbm << " dBm");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/test/block-ack-test-suite.cc ns-3.40/src/wifi/test/block-ack-test-suite.cc
--- ns-3.39/src/wifi/test/block-ack-test-suite.cc	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/test/block-ack-test-suite.cc	2023-09-27 13:30:37.922839900 -0700
@@ -1284,7 +1284,7 @@
     uint16_t aid6 = 2045;
     bool ackType6 = true;
     uint8_t tid6 = 6;
-    Mac48Address address6 = Mac48Address("00:00:00:00:00:01");
+    Mac48Address address6("00:00:00:00:00:01");
 
     blockAck.SetAid11(aid6, 5);
     blockAck.SetAckType(ackType6, 5);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/test/channel-access-manager-test.cc ns-3.40/src/wifi/test/channel-access-manager-test.cc
--- ns-3.39/src/wifi/test/channel-access-manager-test.cc	2023-07-05 14:23:48.125428400 -0700
+++ ns-3.40/src/wifi/test/channel-access-manager-test.cc	2023-09-27 13:30:37.922839900 -0700
@@ -650,7 +650,7 @@
 {
     Simulator::Run();
 
-    for (typename TxopTests::const_iterator i = m_txop.begin(); i != m_txop.end(); i++)
+    for (auto i = m_txop.begin(); i != m_txop.end(); i++)
     {
         Ptr<TxopTest<TxopType>> state = *i;
         NS_TEST_EXPECT_MSG_EQ(state->m_expectedGrants.empty(), true, "Have no expected grants");
@@ -836,6 +836,7 @@
     Simulator::Schedule(MicroSeconds(at) - Now(),
                         &ChannelAccessManager::NotifySwitchingStartNow,
                         m_ChannelAccessManager,
+                        nullptr,
                         MicroSeconds(duration));
 }
 
